package jp.ac.tuis.sample.sort;

/**
 * {@link AbstractedSorter}̃}[W\[gɂłB
 * ɔz𐶐ɔjׁAJVM̃Kx[WRNV̉e󂯂₷Ȃ܂B
 * @author T.Yamaguchi
 */
public class MergeSort extends AbstractedSorter implements Runnable{
    
    /**
     * {@inheritDoc}
     */
    @Override
    protected void sort() {
        int cellsize = 1;
        double[][] current = new double[(int) Math.ceil((double) size() / cellsize)][cellsize];
        for (int i = 0; i < current.length; i++) {
            current[i][0] = get(i);
        }
        while (current.length > 1) {
            cellsize *= 2;
            double[][] next = new double[(int) Math.ceil((double) size() / cellsize)][];
            for (int i = 0; i < next.length; i++) {
                if (i * 2 + 1 < current.length) {
                    next[i] = merge(current[i * 2], current[i * 2 + 1]);
                } else {
                    next[i] = current[i * 2];
                }
            }
            current = next;
        }
        setArray(current[0]);
    }

    protected double[] merge(double[] a, double[] b) {
        double[] r = new double[a.length + b.length];
        int i = 0;
        int j = 0;
        for (int c = 0; c < r.length; c++) {
            if (j >= b.length || (i < a.length && a[i] < b[j])) {
                r[c] = a[i];
                i++;
            } else {
                r[c] = b[j];
                j++;
            }
        }
        return r;
    }
}
