package jp.ac.tuis.sample.test;

import java.util.Random;

/**
 * lɂ\[gp̖񋟂NXłB
 *
 * @author T.Yamaguchi
 */
public class RandomArrayProblem extends Problem {

    protected final Random random;

    /**
     * z̒Ǝ񐔂ɉAWFl[^w肵܂B
     *
     * @param size z̒
     * @param testNumber 
     * @param random WFl[^
     */
    public RandomArrayProblem(int size, int testNumber, Random random) {
        super(size, testNumber);
        this.random = random;
    }

    /**
     * z̒Ǝ񐔂w肵܂BWFl[^̓fBtHg̃V[hŏ܂B
     *
     * @param size z̒
     * @param testNumber 
     */
    public RandomArrayProblem(int size, int testNumber) {
        this(size, testNumber, new Random());
    }

    /**
     * z̒Ǝ񐔂ɉAWFl[^̃V[hw肵܂B
     *
     * @param size z̒
     * @param testNumber 
     * @param seed V[h
     */
    public RandomArrayProblem(int size, int testNumber, long seed) {
        this(size, testNumber, new Random(seed));
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected void initProblem() {
        double[][] problems = new double[getTestNumber()][size()];
        setProblems(problems);
        for (int k = 0; k < getTestNumber(); k++) {
            for (int i = 0; i < size(); i++) {
                problems[k][i] = random.nextDouble();
            }
        }
    }

}
