package jp.ac.tuis.sample.sort;

/**
 * {@link AbstractedSorter}̃}[W\[gɂʎłB
 * ɔz𐶐ȂׁAŃKx[WRNV̉e󂯂ɂȂ܂B
 * @author T.Yamaguchi
 */
public class MergeSortEx extends AbstractedSorter implements Runnable {

    double[] secondary;

    /**
     * {@inheritDoc}
     */
    @Override
    protected void sort() {
        secondary = new double[size()];
        int step = 1;
        while (step < secondary.length) {
            merge(step);
            flip();
            step *= 2;
        }
    }

    protected void merge(int step) {
        for (int k = 0; k < size(); k += step * 2) {
            int i = k;
            int j = k + step;
            int iend = j;
            int end = j + step;
            if (end > secondary.length) {
                end = secondary.length;
            }
            for (int c = k; c < end; c++) {
                if ((j >= end || (i < iend && compare(i, j) < 0))) {
                    secondary[c] = get(i);
                    i++;
                } else {
                    secondary[c] = get(j);
                    j++;
                }
            }
        }
    }

    protected void flip() {
        double[] tmp = getArray();
        setArray(secondary);
        secondary = tmp;
    }

}
