/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package jp.ac.tuis.sample.sort;

/**
 * {@link AbstractedSorter}̃NCbN\[g̎łB
 * @author T.Yamaguchi
 */
public class QuickSort extends AbstractedSorter {

    /**
     * {@inheritDoc}
     */
    @Override
    protected void sort() {
        quickSort(0, size() - 1);
    }

    private int getPivotIndex(int i, int j) {
        int k = i + 1;
        while (k <= j && get(i) == get(k)) {
            k++;
        }
        if (k > j) {
            return -1;
        }
        if (get(i) >= get(k)) {
            return i;
        }
        return k;
    }

    private int partition(int left, int right, double pivot) {
        int l = left, r = right;
        while (l <= r) {
            while (l <= right && get(l) < pivot) {
                l++;
            }
            while (r >= left && get(r) >= pivot) {
                r--;
            }
            if (l > r) {
                break;
            }
            swap(l, r);
            l++;
            r--;
        }
        return l;
    }

    private void quickSort(int i, int j) {
        if (i != j) {
            int p = getPivotIndex(i, j);
            if (p >= 0) {
                int k = partition(i, j, get(p));
                quickSort(i, k - 1);
                quickSort(k, j);
            }
        }
    }
}
