package jp.ac.tuis.sample.test;

import java.util.Arrays;

/**
 * \[gp̖񋟂钊ۃNXłB 
 * z̒Ǝ񐔂w肵܂B
 *
 * @author T.Yamaguchi
 */
public abstract class Problem {

    private double[][] problems;
    private double[][] results;
    private final int size;
    private final int testNumber;

    /**
     * z̒Ǝ񐔂w肵܂B
     * @param size z̒
     * @param testNumber 
     */
    public Problem(int size, int testNumber) {
        this.size = size;
        this.testNumber = testNumber;
    }

    /**
     * ƂȂzƂ̐𐶐܂B
     */
    public void init() {
        initProblem();
        initResult();
    }

    /**
     * ƂȂz𐶐܂BI[o[ChĖĂB
     */
    protected abstract void initProblem();

    protected void initResult() {
        results = new double[testNumber][];
        for (int k = 0; k < testNumber; k++) {
            results[k] = Arrays.copyOf(problems[k], problems[k].length);
            Arrays.sort(results[k]);
        }
    }

    /**
     * z̒Ԃ܂
     * @return z̒Ԃ܂
     */
    public int size() {
        return size;
    }

    /**
     * 񐔂Ԃ܂
     * @return 񐔂Ԃ܂
     */
    public int getTestNumber() {
        return testNumber;
    }

    /**
     * w肵ԍ̖Ԃ܂
     * @param k ԍw肵܂Bk{@link Problem#testNumber}ȉłȂĂ͂Ȃ܂B
     * @return ̔zԂ܂
     */
    public double[] getProblems(int k) {
        return problems[k];
    }

    /**
     * S̔zZbg܂
     * @param problems Q̐{@link Problem#testNumber}ƓKv܂B
     */
    protected void setProblems(double[][] problems) {
        this.problems = problems;
    }
    /**
     * w肵ԍ̌ʂԂ܂
     * @param k ʂ̔ԍw肵܂Bk{@link Problem#testNumber}ȉłȂĂ͂Ȃ܂B
     * @return ʂ̔zԂ܂
     */
    public double[] getResult(int k) {
        return results[k];
    }

    /**
     * ʂo͂܂B
     */
    public void print() {
        System.out.print(this.getClass().getName());
        System.out.print(" z񒷁F");
        System.out.print(size);
        System.out.print(" eXg");
        System.out.print(testNumber);
        System.out.println();
    }
}
